(*****************************************************************************
 * HOL-TestGen --- theorem-prover based test case generation
 *                 http://www.brucker.ch/projects/hol-testgen/
 *                                                                            
 * wrapper.sml --- wrapper for calling RBT deleteimplementation 
 * This file is part of HOL-TestGen.
 *
 * Copyright (c) 2005-2007, ETH Zurich, Switzerland
 *
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *
 *     * Redistributions in binary form must reproduce the above
 *       copyright notice, this list of conditions and the following
 *       disclaimer in the documentation and/or other materials provided
 *       with the distribution.
 *
 *     * Neither the name of the copyright holders nor the names of its
 *       contributors may be used to endorse or promote products derived
 *       from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ******************************************************************************)
(* $Id: wrapper.sml 11263 2015-01-28 22:39:06Z brucker $ *)

structure wrapper = 
struct
(* open IntRedBlackSet;  *)

datatype color = R | B
datatype tree
      = E
      | T of (color * tree * IntInf.int * tree)

type 'a Tree = tree


fun fromIntRedBlackSet IntRedBlackSet.E = E
  | fromIntRedBlackSet (IntRedBlackSet.T(IntRedBlackSet.R,t1,e,t2)) = T(R, fromIntRedBlackSet t1, IntInf.fromInt(e), fromIntRedBlackSet t2) 
  | fromIntRedBlackSet (IntRedBlackSet.T(IntRedBlackSet.B,t1,e,t2)) = T(B, fromIntRedBlackSet t1, IntInf.fromInt(e), fromIntRedBlackSet t2) 

fun toIntRedBlackSet E = IntRedBlackSet.E
  | toIntRedBlackSet (T(R,t1,e,t2)) = IntRedBlackSet.T(IntRedBlackSet.R, toIntRedBlackSet t1, IntInf.toInt(e), toIntRedBlackSet t2) 
  | toIntRedBlackSet (T(B,t1,e,t2)) = IntRedBlackSet.T(IntRedBlackSet.B, toIntRedBlackSet t1, IntInf.toInt(e), toIntRedBlackSet t2) 

fun del  (e,s)  =  let 
                       val retset = IntRedBlackSet.delete  ((IntRedBlackSet.SET(0,toIntRedBlackSet s)),IntInf.toInt e); 
	               val (IntRedBlackSet.SET(_,ret)) = retset;
		 in fromIntRedBlackSet ret end

end
